#include "stdafx.h"
#include "wrap.h"
#include "wrapdlg.h"
#include "threads.h"
#include "connection.h"
#include "sslconn.h"
#include "ftplines.h"
#include <openssl/err.h>
#include <openssl/ssl.h>

#ifdef _DEBUG
#endif

IMPLEMENT_DYNCREATE(CExampleThread, CWinThread)

CExampleThread::CExampleThread()
{
	hoe_threadDone = 0;
	hoe_threadOwner = NULL;
	m_bAutoDelete=FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// CListenThread

IMPLEMENT_DYNCREATE(CListenThread, CExampleThread)

CListenThread::CListenThread()
{
}

CListenThread::~CListenThread()
{
}

BOOL CListenThread::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

void CListenThread::AddToLog(LPCTSTR szBuffer)
{
	hoe_threadOwner->AddToLog(szBuffer); 
}

void CListenThread::CheckThreads(void)
{
	CWrapThread *ctemp;
	DWORD   dwStatus;

	CSingleLock sLock(&hoe_threadOwner->m_threadsmutex);
	sLock.Lock();
	//lets look for finished threads and remove them
	//from thread list
	POSITION pos=hoe_threadOwner->m_pWrapThreads->GetHeadPosition();
	POSITION pos2;
	while (pos!=NULL) {
		pos2=pos;
		hoe_threadOwner->m_pWrapThreads->GetNext(pos);
		ctemp=hoe_threadOwner->m_pWrapThreads->GetAt(pos2);
		if (ctemp!=NULL) {
			VERIFY(::GetExitCodeThread(ctemp->m_hThread, &dwStatus));
			if (dwStatus != STILL_ACTIVE)
			{
				hoe_threadOwner->m_pWrapThreads->RemoveAt(pos2);
				delete ctemp;
				//well now its time to refresh some shit
				hoe_threadOwner->PostMessage(WM_USER+1,2,0);
				//ctemp->thread = NULL;
				//head->next=ctemp->next;
				//delete ctemp;
			} else {
				if (this->hoe_threadDone==1) ctemp->hoe_threadDone=1;
			}
		}
	}
	sLock.Unlock();
}

int CListenThread::Run()
{ 
	int clnt,err,client_len;
	CString buf;
	//fd_set fdsr, fdse,fdsw;
	unsigned long cmdpar;
	CWrapThread *ctemp;
	CThreadConfig* conf;
	struct hostent *h;
	//  int nCount;
	//  int bytes=0,totbytes=0;
	//static struct WSAData wsa_state;
	//static int wsa_init_done=0;

	client_len = sizeof(sockaddr_in);
	ASSERT(hoe_threadOwner != NULL);
	if (hoe_threadOwner == NULL) 
		return -1;


	CButton* pCheck = (CButton*) hoe_threadOwner->GetDlgItem(IDC_STARTSTOP);
	if (this->hoe_threadOwner->m_pThreadConfigs->GetCount()==0) {
		this->AddToLog("No services defined !");
		pCheck->SetWindowText("&Start");
		return 0;
	}

	pCheck->SetWindowText("&Stop");

	POSITION pos=hoe_threadOwner->m_pThreadConfigs->GetHeadPosition();
	while (pos) {
		conf=hoe_threadOwner->m_pThreadConfigs->GetNext(pos);
		if (!conf->enabled) {
			conf->sd=-1;
			continue;
		}
		conf->sd = socket (AF_INET, SOCK_STREAM, 0);

		memset (&conf->sa, '\0', sizeof(conf->sa));

		conf->sa.sin_family      = AF_INET;
		if (conf->inhost=="") {
			conf->sa.sin_addr.s_addr = INADDR_ANY;   /* Server IP */
			conf->inhostreal="ANY";
			conf->inhostip="0.0.0.0";
		}
		else {
			h=gethostbyname(conf->inhost);
			if (h==NULL) {
				conf->inhostreal=conf->inhost;
				conf->inhostip=conf->inhost;
				conf->sa.sin_addr.s_addr = inet_addr(conf->inhost);   /* Server IP */
			} else {
				conf->inhostreal=h->h_name;
				memcpy(&conf->sa.sin_addr,h->h_addr_list[0],h->h_length);   /* Server IP */
				conf->inhostip=inet_ntoa(conf->sa.sin_addr);
			}

		}
		conf->sa.sin_port = htons((unsigned short)conf->inport);          /* Server Port number */

		err = bind(conf->sd, (struct sockaddr*) &conf->sa,sizeof (conf->sa)); 
		if (err==SOCKET_ERROR) {
			buf.Format("[%s] Unable to bind to %s (%s), port %d",        
				conf->label,conf->inhostreal,conf->inhostip, conf->inport);
			hoe_threadOwner->AddToLog(buf);
			closesocket(conf->sd);
			conf->sd=-1;
			continue;           
		}
		/* Receive a TCP connection. */
		err = listen (conf->sd, 5);    
		if (err==SOCKET_ERROR) {
			buf.Format("[%s] Unable to listen to %s (%s), port %d",        
				conf->label,conf->inhostreal,conf->inhostip,conf->inport);
			hoe_threadOwner->AddToLog(buf);
			closesocket(conf->sd);
			conf->sd=-1;
			continue;
		}

		buf.Format("[%s] Listening on %s (%s), port %d",        
			conf->label,conf->inhostreal,conf->inhostip, conf->inport);
		AddToLog(buf);


		cmdpar=1;
		ioctlsocket(conf->sd,FIONBIO,&cmdpar);
	}

	//conf=this->m_pOwner->m_pThreadConfigs;
	pos=hoe_threadOwner->m_pThreadConfigs->GetHeadPosition();
	while (!hoe_threadDone) {
		if (pos==NULL) {
			CheckThreads();
			pos=hoe_threadOwner->m_pThreadConfigs->GetHeadPosition();
			Sleep(500);
		}
		conf=hoe_threadOwner->m_pThreadConfigs->GetNext(pos);
		if (conf->sd!=-1) {
			clnt=accept(conf->sd, (struct sockaddr*) &conf->sa, &client_len);
			if (clnt<0) {
				err=WSAGetLastError();
				if (err!=WSAEWOULDBLOCK) {
					hoe_threadOwner->AddToLog("error accepting !");
					//maybe remove this
					//conf->sd=-1; //we totally stop accepting in this port
				}
			} else {
				//sprintf(buf,"accept() = %d", clnt);
				//m_pOwner->AddToLog((LPCTSTR)buf);
				conf->fromip=inet_ntoa(conf->sa.sin_addr);
				conf->fromhost=inet_ntoa(conf->sa.sin_addr);
				conf->fromport=ntohs(conf->sa.sin_port);
				buf.Format("[%s] Connection from %s, port %d",        
					conf->label,inet_ntoa(conf->sa.sin_addr), ntohs(conf->sa.sin_port));
				AddToLog(buf);
				//ctemp=new(CWrapThread);
				ctemp = (CWrapThread*)
					AfxBeginThread(RUNTIME_CLASS(CWrapThread), THREAD_PRIORITY_NORMAL,
					0, CREATE_SUSPENDED);

				ctemp->SetOwner(hoe_threadOwner);
				ctemp->SetUp(clnt,hoe_threadOwner->ssl_ctx,hoe_threadOwner->ssl_ctx_server,conf);
				CSingleLock sLock(&hoe_threadOwner->m_threadsmutex);
				sLock.Lock();
				hoe_threadOwner->m_pWrapThreads->AddTail(ctemp);
				sLock.Unlock();
				//add the new thread to thread list
				//new thread will be has blocking clnt socket
				ctemp->ResumeThread();
			}
		}
	}
	//quit loop, wait for all threads to quit
	if (this->hoe_threadDone!=2) {
		do {
			this->CheckThreads();
			Sleep(200);
		} while (!hoe_threadOwner->m_pWrapThreads->IsEmpty());
	}

	pos=hoe_threadOwner->m_pThreadConfigs->GetHeadPosition();
	for (int fori=0;fori<hoe_threadOwner->m_pThreadConfigs->GetCount();fori++) {
		conf=hoe_threadOwner->m_pThreadConfigs->GetNext(pos);
		if (conf->sd!=-1) {
			closesocket(conf->sd);
			buf.Format("[%s] Stopped listening on %s (%s), port %d",        
				conf->label,conf->inhostreal,conf->inhostip, conf->inport);
			AddToLog(buf);
		}
	}

	pCheck->SetWindowText("&Start");
	return 0;
}

BEGIN_MESSAGE_MAP(CListenThread, CWinThread)
	//{{AFX_MSG_MAP(CListenThread)
	// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListenThread message handlers

