#pragma once

// threads.h : header file

#include "connection.h"
#include <openssl/err.h>
#include <openssl/ssl.h>

class CMainDlg;

class CExampleThread : public CWinThread
{
        DECLARE_DYNCREATE(CExampleThread)
protected:
        CExampleThread();

public:
        CMainDlg* hoe_threadOwner;
        int hoe_threadDone;

        void SetOwner(CMainDlg* pOwner) { hoe_threadOwner = pOwner; };
};

/////////////////////////////////////////////////////////////////////////////
// CWrapThread thread

class CWrapThread : public CExampleThread
{
        DECLARE_DYNCREATE(CWrapThread)
protected:
        CWrapThread();           // protected constructor used by dynamic creation
        void showsslinfo(SSL *ssl);
        // Attributes
public:
        // Operations
		void AddToLog(LPCTSTR szBuffer);

private:
        int ResolveOut();
        CConnection * ConnectWrap();
        int DoFTPProxyAuth(CConnection *lcon);
        int DoBounce(CConnection *lcon,CConnection *ccon);

        struct sockaddr_in hoe_SockAddr;
        int hoe_clntSock;
        SSL *hoe_sslin,*hoe_sslout;
        SSL_CTX *hoe_ssl_ctx,*hoe_ssl_ctx_server;


public:
        BOOL SetUp(int clnt,SSL_CTX* ssl_ctx,SSL_CTX* ssl_ctx_server,CThreadConfig* thr);
        void SetOwner(CMainDlg* pOwner) { hoe_threadOwner = pOwner; };
//      CMutex m_mutex;
        //ugly
        CThreadConfig hoe_threadConf;

        // Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CWrapThread)
public:
        virtual BOOL InitInstance();
        virtual int Run();
        //}}AFX_VIRTUAL

        // Implementation
public:
        virtual ~CWrapThread();

        // Generated message map functions
        //{{AFX_MSG(CWrapThread)
        // NOTE - the ClassWizard will add and remove member functions here.
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// CListenThread thread

class CListenThread : public CExampleThread
{
        DECLARE_DYNCREATE(CListenThread)
protected:
        CListenThread();           // protected constructor used by dynamic creation

        // Attributes
public:

        // Operations
public:
        void AddToLog(LPCTSTR szBuffer);

        // Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CListenThread)
public:
        virtual BOOL InitInstance();
        virtual int Run();
        //}}AFX_VIRTUAL
private:
        void CheckThreads(void);
        // Implementation
public:
        virtual ~CListenThread();

        // Generated message map functions
        //{{AFX_MSG(CListenThread)
        // NOTE - the ClassWizard will add and remove member functions here.
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
