// Connection.cpp: implementation of the CConnection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "wrap.h"
#include "Connection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define readsocket(s,b,n)       recv((s),(b),(n),0)
#define writesocket(s,b,n)      send((s),(b),(n),0)



int CConnection::read(void *buf,int count) {
int i;
        wantread=0;
        if ((i=readsocket(this->sock,(char *)buf,count))==-1) {
                i=WSAGetLastError();
                if (i==WSAEWOULDBLOCK) {
                        wantread=1;
                        return 0;
                } else {
                        return -1;
                }
        } else return i;
};

int CConnection::write(CString s) {
  return write(LPCTSTR(s),s.GetLength());
}

int CConnection::write(const void *buf,int count) {
int i;
again:
        if ((i=writesocket(this->sock,(char *)buf,count))==-1) {
                i=WSAGetLastError();
                if (i==WSAEWOULDBLOCK) {
                        //Sleep(1);
                        goto again;
                }else return -1;
        } else return i;
};

int CConnection::close() {
 return closesocket(this->sock);
};

CConnection::CConnection(int sck)
{
        this->sock=sck;
        linetemp="";
        wantread=0;
}

CConnection::~CConnection()
{
}
//#define BUFLEN 4096
/*#define GETLINE_OK 0
#define GETLINE_ERROR -1
#define GETLINE_NO_DATA 1
#define GETLINE_NOT_WHOLE_LINE 2
*/
int CConnection::GetLine(CString *str)
//returns -1 - error
//         0 - ok, line returned
//         1 - nothing to read
//         2 - read data but not whole line
{
        int i,i1;
        CString line;
//first check if we dont have line already ready
        i=linetemp.Find("\r\n");
        if (i!=-1) {
                line=linetemp.Left(i);
                linetemp=linetemp.Right(linetemp.GetLength()-i-2);
                *str=line;
                return 0;
        }

        i=this->read(buf,BUFLEN-1);
        if (i==0) return 1;
        if (i<0) return -1;
        
        for (i1=0;i1<i;i1++) {
                if (buf[i1]=='\0') {
                        buf[i1]='_';
                }
        }
        buf[i1]='\0';

        linetemp=linetemp+buf;
        i=linetemp.Find("\r\n");
        if (i!=-1) {
                line=linetemp.Left(i);
                linetemp=linetemp.Right(linetemp.GetLength()-i-2);
                *str=line;
                return 0;
        }
        return 2;
}
