// Connection.h: interface for the CConnection class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include <openssl/err.h>
#include <openssl/ssl.h>

#define GETLINE_OK 0
#define GETLINE_ERROR -1
#define GETLINE_NO_DATA 1
#define GETLINE_NOT_WHOLE_LINE 2

#define BUFLEN 4096
#define readsocket(s,b,n)       recv((s),(b),(n),0)
#define writesocket(s,b,n)      send((s),(b),(n),0)

class CConnection  
{
public:
	int GetLine(CString *str);
	CConnection(int sck);
    virtual int read(void *buf,int count);
    virtual int write(const void *buf,int count);
	int write(CString s);
	virtual int close();
	virtual ~CConnection();
	int wantread;
    int sock;
private:
	char buf[BUFLEN];
	CString linetemp;
    //void *sockid;
};

