// Configdlg.cpp : implementation file
//

#include "stdafx.h"
#include "wrap.h"
#include "servicesdlg.h"
#include "threads.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// CServicesDlg dialog


CServicesDlg::CServicesDlg(CWnd* pParent /*=NULL*/)
: CDialog(CServicesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServicesDlg)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CServicesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServicesDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CServicesDlg, CDialog)
	//{{AFX_MSG_MAP(CServicesDlg)
	ON_BN_CLICKED(ID_CONFIG_OK, OnConfigOk)
	ON_BN_CLICKED(ID_CONFIG_CANCEL, OnConfigCancel)
	ON_WM_CLOSE()
	ON_LBN_SELCHANGE(IDC_CONFIG_LIST, OnSelchangeConfigList)
	ON_BN_CLICKED(IDC_CONFIG_ADD, OnConfigAdd)
	ON_BN_CLICKED(IDC_CONFIG_DELETE, OnConfigDelete)
	ON_EN_CHANGE(IDC_CONFIG_NAME, OnChangeConfigName)
	ON_CBN_SELCHANGE(IDC_CONFIG_TYPE, GetValues)
	ON_BN_CLICKED(IDC_CONFIG_ENABLED, GetValues)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServicesDlg message handlers

void CServicesDlg::OnConfigOk() 
{
	this->GetValues();
	this->quitway=0;
	PostMessage(WM_CLOSE, 0, 0);
	//      this->EndDialog(IDOK);  
}

void CServicesDlg::OnConfigCancel() 
{
	this->quitway=1;
	PostMessage(WM_CLOSE, 0, 0);
	//      this->EndDialog(IDCANCEL);      
}


BOOL CServicesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CListBox* list=(CListBox*)GetDlgItem(IDC_CONFIG_LIST);
	ASSERT(list);
	CThreadConfig *conf;
	//    head=this->m_pThreadConfig;

	int i;
	//CButton* pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_ENABLED);
	//pCheck->SetButtonStyle(BS_OWNERDRAW,FALSE);

	POSITION pos = m_pThreadConfigs->GetHeadPosition();
	for (int count=0;count < m_pThreadConfigs->GetCount();count++)
	{
		conf=m_pThreadConfigs->GetNext(pos);
		i=list->AddString(conf->label);
		list->SetItemDataPtr(i,(void*)conf);
	}
	list->SetCurSel(0);

	CComboBox* type=(CComboBox*)GetDlgItem(IDC_CONFIG_TYPE);
	ASSERT(type);
	type->AddString("SSL Tunnel");
	type->AddString("FTP Proxy");

	type=(CComboBox*)GetDlgItem(IDC_CONFIG_FTPTYPE);
	ASSERT(type);
	type->AddString("AUTH TLS");
	type->AddString("FTPS");

	this->m_pThreadConfigCurrent=NULL;

	conf=(CThreadConfig *)list->GetItemDataPtr(0);
	if (conf==(CThreadConfig *)-1) conf=NULL;
	SetValues(conf);
	this->m_pThreadConfigCurrent=conf;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CServicesDlg::OnClose() 
{
	//    CThreadConfig *head,*conf;
	unsigned long dwStatus;
	if (quitway==0) {      
		CButton* pCheck1 = (CButton*) this->hoe_threadOwner->GetDlgItem(IDC_PAUSE);
		ASSERT(pCheck1);
		BOOL bPaused = ((pCheck1->GetState() & 0x003) != 0);

		if (bPaused == TRUE)
		{
			this->hoe_threadOwner->m_pListenThread->ResumeThread();
		}

		this->hoe_threadOwner->m_pListenThread->hoe_threadDone=2;
		VERIFY(::GetExitCodeThread(hoe_threadOwner->m_pListenThread->m_hThread, &dwStatus));
		if (dwStatus != STILL_ACTIVE) {
			while (!hoe_threadOwner->m_pThreadConfigs->IsEmpty()) {
				delete hoe_threadOwner->m_pThreadConfigs->RemoveHead();
			}			
			delete hoe_threadOwner->m_pThreadConfigs;
			hoe_threadOwner->m_pThreadConfigs=m_pThreadConfigs;
			this->m_pThreadConfigs=NULL;

			hoe_threadOwner->WriteConfigFile();

			delete hoe_threadOwner->m_pListenThread;
			hoe_threadOwner->m_pListenThread = (CListenThread*)
				AfxBeginThread(RUNTIME_CLASS(CListenThread), THREAD_PRIORITY_NORMAL,
				0, CREATE_SUSPENDED);
			hoe_threadOwner->m_pListenThread->SetOwner(hoe_threadOwner);

			CButton* pCheck1 = (CButton*) hoe_threadOwner->GetDlgItem(IDC_PAUSE);
			ASSERT(pCheck1!=NULL);
			BOOL bPaused = ((pCheck1->GetState() & 0x003) != 0);

			if (bPaused != TRUE)
				hoe_threadOwner->m_pListenThread->ResumeThread();

			CDialog::OnClose();
			return;
		}
		Sleep(10);
		PostMessage(WM_CLOSE, 0, 0);		
	}
	else {
		while (!m_pThreadConfigs->IsEmpty()) {
			delete m_pThreadConfigs->RemoveHead();
		}			
		delete m_pThreadConfigs;
		CDialog::OnClose();
	}
}

void CServicesDlg::SetValues(CThreadConfig *conf)
{
	CString str;

	if (conf!=NULL) {
		CComboBox* type=(CComboBox*)GetDlgItem(IDC_CONFIG_TYPE);
		ASSERT(type);
		type->EnableWindow(TRUE);
		type->SetCurSel(conf->type);

		CEdit *edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_NAME);
		ASSERT(edit);
		//		edit->SetReadOnly(FALSE);
		edit->EnableWindow(TRUE);
		edit->SetWindowText(conf->label);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_INHOST);
		ASSERT(edit);
		edit->EnableWindow(TRUE);
		//		edit->SetReadOnly(FALSE);
		edit->SetWindowText(conf->inhost);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_INPORT);
		ASSERT(edit);
		edit->EnableWindow(TRUE);
		//		edit->SetReadOnly(FALSE);
		str.Format("%d",conf->inport);
		edit->SetWindowText(str);

		CButton* pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_ENABLED);
		pCheck->EnableWindow(TRUE);
		pCheck->SetCheck(conf->enabled);
		if (conf->type==1) {
			type=(CComboBox*)GetDlgItem(IDC_CONFIG_FTPTYPE);
			ASSERT(type);
			type->ShowWindow(SW_SHOW);
			type->SetCurSel(conf->ftptype);

			CStatic *stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMOTE);
			ASSERT(stat);
			stat->ShowWindow(SW_HIDE);

			stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMPORT);
			ASSERT(stat);
			stat->ShowWindow(SW_HIDE);

			stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMFTP);
			ASSERT(stat);
			stat->ShowWindow(SW_SHOW);

			edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTHOST);
			ASSERT(edit);
			edit->ShowWindow(SW_HIDE);

			edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTPORT);
			ASSERT(edit);
			edit->ShowWindow(SW_HIDE);

			pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLIN);
			pCheck->ShowWindow(SW_HIDE);

			pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLOUT);
			pCheck->ShowWindow(SW_HIDE);

			pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_REJECT);
			pCheck->ShowWindow(SW_SHOW);
			pCheck->SetCheck(conf->ftpreject);

		} else {
			type=(CComboBox*)GetDlgItem(IDC_CONFIG_FTPTYPE);
			ASSERT(type);
			type->ShowWindow(SW_HIDE);

			CStatic *stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMOTE);
			ASSERT(stat);
			stat->ShowWindow(SW_SHOW);

			stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMFTP);
			ASSERT(stat);
			stat->ShowWindow(SW_HIDE);

			stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMPORT);
			ASSERT(stat);
			stat->ShowWindow(SW_SHOW);

			edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTHOST);
			ASSERT(edit);
			//		edit->SetReadOnly(FALSE);
			edit->ShowWindow(SW_SHOW);
			edit->EnableWindow(TRUE);
			edit->SetWindowText(conf->outhost);

			edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTPORT);
			ASSERT(edit);
			str.Format("%d",conf->outport);
			edit->ShowWindow(SW_SHOW);
			edit->EnableWindow(TRUE);
			edit->SetWindowText(str);

			pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLIN);
			pCheck->ShowWindow(SW_SHOW);
			pCheck->EnableWindow(TRUE);
			pCheck->SetCheck(conf->sslin);

			pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLOUT);
			pCheck->ShowWindow(SW_SHOW);
			pCheck->EnableWindow(TRUE);
			pCheck->SetCheck(conf->sslout);

			pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_REJECT);
			pCheck->ShowWindow(SW_HIDE);

		}
	} else {
		CEdit *edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_NAME);
		ASSERT(edit);
		edit->SetWindowText("");
		//edit->SetReadOnly(TRUE);
		edit->EnableWindow(FALSE);

		CComboBox* type=(CComboBox*)GetDlgItem(IDC_CONFIG_TYPE);
		ASSERT(type);
		type->SetCurSel(0);
		type->EnableWindow(FALSE);		
		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_INHOST);
		ASSERT(edit);
		edit->SetWindowText("");
		//		edit->SetReadOnly(TRUE);
		edit->EnableWindow(FALSE);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_INPORT);
		ASSERT(edit);
		edit->SetWindowText("");
		//		edit->SetReadOnly(TRUE);
		edit->EnableWindow(FALSE);

		CButton* pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_ENABLED);
		pCheck->EnableWindow(FALSE);
		pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLIN);
		pCheck->EnableWindow(FALSE);
		pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLOUT);
		pCheck->EnableWindow(FALSE);

		type=(CComboBox*)GetDlgItem(IDC_CONFIG_FTPTYPE);
		ASSERT(type);
		type->ShowWindow(SW_HIDE);

		CStatic *stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMOTE);
		ASSERT(stat);
		stat->ShowWindow(SW_HIDE);

		stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMFTP);
		ASSERT(stat);
		stat->ShowWindow(SW_HIDE);

		stat=(CStatic*)this->GetDlgItem(IDC_STATIC_REMPORT);
		ASSERT(stat);
		stat->ShowWindow(SW_SHOW);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTHOST);
		ASSERT(edit);
		edit->ShowWindow(SW_HIDE);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTPORT);
		ASSERT(edit);
		edit->ShowWindow(SW_HIDE);

		pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_REJECT);
		pCheck->ShowWindow(SW_HIDE);

	}
}

void CServicesDlg::OnSelchangeConfigList() 
{
	CThreadConfig* head;
	int i;

	//	i=0;
	CListBox* list=(CListBox*)GetDlgItem(IDC_CONFIG_LIST);
	ASSERT(list);
	/*
	head=this->m_pThreadConfig;
	while ((head!=NULL)&&(i<list->GetCurSel())) {
	head=head->next;	
	i++;
	}*/
	this->GetValues();
	i=list->GetCurSel();
	head=(CThreadConfig *)list->GetItemDataPtr(i);
	ASSERT(head!=(CThreadConfig *)-1);
	this->m_pThreadConfigCurrent=NULL;
	this->SetValues(head);
	this->m_pThreadConfigCurrent=head;
}

void CServicesDlg::GetValues()
{
	CString str;
	bool setval=FALSE;
	int beforetype;

	CThreadConfig *conf=this->m_pThreadConfigCurrent;
	if (conf!=NULL) {
		CEdit *edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_NAME);
		ASSERT(edit);
		edit->GetWindowText(conf->label);

		CComboBox* type=(CComboBox*)GetDlgItem(IDC_CONFIG_TYPE);
		ASSERT(type);
		beforetype=conf->type;
		if (conf->type!=type->GetCurSel()) {
			conf->type=type->GetCurSel();
			setval=TRUE;
		}

		if (beforetype==1) {
			type=(CComboBox*)GetDlgItem(IDC_CONFIG_FTPTYPE);
			ASSERT(type);
			conf->ftptype=type->GetCurSel();
		} else {
			conf->ftptype=0;
		}


		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_INHOST);
		ASSERT(edit);
		edit->GetWindowText(conf->inhost);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_INPORT);
		ASSERT(edit);
		edit->GetWindowText(str);
		conf->inport=atoi(str);

		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTHOST);
		ASSERT(edit);
		edit->GetWindowText(conf->outhost);
		edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_OUTPORT);
		ASSERT(edit);
		edit->GetWindowText(str);
		conf->outport=atoi(str);

		CButton* pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_ENABLED);
		conf->enabled=pCheck->GetCheck();

		pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLIN);
		conf->sslin=pCheck->GetCheck();

		pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_REJECT);
		conf->ftpreject=pCheck->GetCheck();

		pCheck=(CButton*)this->GetDlgItem(IDC_CONFIG_SSLOUT);
		conf->sslout=pCheck->GetCheck();
		if (setval) {
			this->m_pThreadConfigCurrent=NULL;
			this->SetValues(conf);
			this->m_pThreadConfigCurrent=conf;
		}
	}
	return;
}

void CServicesDlg::OnConfigAdd() 
{
	int i;

	CThreadConfig *tmp;
	tmp=new CThreadConfig;
	tmp->enabled=TRUE;
	tmp->inhost="";
	tmp->outhost="";
	tmp->label="new";
	tmp->inport=0;
	tmp->outport=0;
	tmp->type=0;
	tmp->sslin=FALSE;
	tmp->sslout=FALSE;
	tmp->ftpreject=FALSE;
	tmp->ftptype=0;
	//	tmp->next=NULL;

	CListBox* list=(CListBox*)GetDlgItem(IDC_CONFIG_LIST);
	ASSERT(list);
	i=list->AddString("new");
	list->SetCurSel(i);
	list->SetItemDataPtr(i,tmp);
	m_pThreadConfigs->AddTail(tmp);
	this->OnSelchangeConfigList();	
	this->m_pThreadConfigCurrent=tmp;
	this->SetValues(tmp);
}

void CServicesDlg::OnConfigDelete() 
{
	CThreadConfig *conf;
	int i;
	CListBox* list=(CListBox*)GetDlgItem(IDC_CONFIG_LIST);
	ASSERT(list);
	i=list->GetCurSel();
	if (i==LB_ERR) {
		return;
	}
	conf=(CThreadConfig*)list->GetItemDataPtr(i);
	m_pThreadConfigs->RemoveAt(m_pThreadConfigs->Find(conf));
	delete conf;
	list->DeleteString(i);
	if (i==0) i=1;
	if (list->SetCurSel(i-1)==LB_ERR) {
		this->m_pThreadConfigCurrent=NULL;
		this->SetValues(NULL);
	} else {
		conf=(CThreadConfig*)list->GetItemDataPtr(i-1);
		this->m_pThreadConfigCurrent=NULL;
		this->SetValues(conf);
		this->m_pThreadConfigCurrent=conf;
	}
}

void CServicesDlg::OnChangeConfigName() 
{ 
	CThreadConfig* head;
	CString str;
	int i;
	if (this->m_pThreadConfigCurrent!=NULL) {
		CListBox* list=(CListBox*)GetDlgItem(IDC_CONFIG_LIST);
		ASSERT(list);
		CEdit *edit=(CEdit*)this->GetDlgItem(IDC_CONFIG_NAME);
		ASSERT(edit);
		i=list->GetCurSel();
		head=(CThreadConfig *)list->GetItemDataPtr(i);
		list->DeleteString(i);
		edit->GetWindowText(str);
		i=list->AddString(str);
		list->SetItemDataPtr(i,head);
		list->SetCurSel(i);
	}
}


