// SSLConn.cpp: implementation of the CSSLConn class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "wrap.h"
#include "SSLConn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSSLConn::CSSLConn(int sck,SSL *ssl)
:CConnection(sck)
{
	this->sslcon=ssl;
	this->sock=sck;
}

int CSSLConn::read(void *buf,int count) {
	int i,err;
	wantread=0;

	i=SSL_read(this->sslcon,(char *)buf,count);
	if (i!=-1) {
		wantread=SSL_pending(this->sslcon);
		return i;
	}
	err = SSL_get_error(this->sslcon, i);
	if ((err==SSL_ERROR_WANT_READ)||(err==SSL_ERROR_WANT_WRITE)) {
		wantread=1;
		return 0;
	}
	return -1;
};

int CSSLConn::write(const void *buf,int count) {
	int i,err;
again_write:
	i=SSL_write(this->sslcon,(char *)buf,count);
	if (i!=-1) {
		//if (i!=count) ASSERT(0);
		return i;
	}
	err = SSL_get_error(this->sslcon,i);
	if ((err==SSL_ERROR_WANT_READ)||(err==SSL_ERROR_WANT_WRITE)) {
		//ASSERT(0);  
		goto again_write;
	}
	return -1;
};

int CSSLConn::close() {
	SSL_shutdown(this->sslcon);
	SSL_free(this->sslcon);
	closesocket(sock);
	return 0;
}


CSSLConn::~CSSLConn()
{
}
