#include "stdafx.h"
#include "wrap.h"
#include "wrapdlg.h"
#include "threads.h"
#include "connection.h"
#include "sslconn.h"
#include "ftplines.h"
#include <openssl/err.h>
#include <openssl/ssl.h>


/////////////////////////////////////////////////////////////////////////////
// CWrapThread

IMPLEMENT_DYNCREATE(CWrapThread, CExampleThread)

CWrapThread::CWrapThread()//:m_mutex(FALSE,NULL)
{
	//clock=new CSingleLock(&m_mutex);
}

CWrapThread::~CWrapThread()
{
	//delete clock;
}


BOOL CWrapThread::InitInstance()
{
	hoe_sslin=NULL;hoe_sslout=NULL;

	return TRUE;
}

BOOL CWrapThread::SetUp(int clnt,SSL_CTX* ssl_ctx,SSL_CTX* ssl_ctx_server,CThreadConfig* thr)
{
	hoe_threadConf.sa=thr->sa;
	this->hoe_clntSock=clnt; //this-> je dolezite !
	hoe_threadConf.fromhost=thr->fromhost;
	hoe_threadConf.fromip=thr->fromip;
	hoe_threadConf.fromport=thr->fromport;
	hoe_threadConf.outhost=thr->outhost;
	hoe_threadConf.outport=thr->outport;
	hoe_threadConf.sslin=thr->sslin;
	hoe_threadConf.sslout=thr->sslout;
	hoe_threadConf.label=thr->label;
	hoe_threadConf.type=thr->type;
	hoe_threadConf.ftpreject=thr->ftpreject;
	hoe_threadConf.ftptype=thr->ftptype;
	this->hoe_ssl_ctx=ssl_ctx;
	this->hoe_ssl_ctx_server=ssl_ctx_server;
	return TRUE;
}


char *tls_get_commonName(SSL * ssl)
{
	static char name[256];
	int err = 0;
	X509 *server_cert;

	if ((server_cert = SSL_get_peer_certificate(ssl))!=NULL) {
		err = X509_NAME_get_text_by_NID(X509_get_subject_name(server_cert),
			NID_commonName, name,
			sizeof(name));
		X509_free(server_cert);
	}
	if (err > 0)
		return name;
	else
		return NULL;
}

char *tls_get_issuer_name(SSL * ssl)
{
	static char name[256];
	X509 *server_cert;

	if ((server_cert = SSL_get_peer_certificate(ssl))!=NULL) {
		X509_NAME_oneline(X509_get_issuer_name(server_cert), name,
			sizeof(name));
		X509_free(server_cert);
		return name;
	} else
		return NULL;
}

char *tls_get_subject_name(SSL * ssl)
{
	static char name[256];
	X509 *server_cert;

	if ((server_cert = SSL_get_peer_certificate(ssl))!=NULL) {
		X509_NAME_oneline(X509_get_subject_name(server_cert), name,
			sizeof(name));
		X509_free(server_cert);
		return name;
	} else
		return NULL;
}


void CWrapThread::showsslinfo(SSL *ssl) {
	char *temp;
	CString str;

	if ((temp = tls_get_subject_name(ssl))!=NULL) {
		str.Format("[%s] Subject: %s",hoe_threadConf.label, temp);
		hoe_threadOwner->AddToLog(str);
	}
	if ((temp = tls_get_issuer_name(ssl))!=NULL) {
		str.Format("[%s] Issuer:  %s",hoe_threadConf.label, temp);
		hoe_threadOwner->AddToLog(str);
	}

	str.Format("[%s] Cipher:  %s (%d bits)",hoe_threadConf.label,
		SSL_get_cipher(ssl),
		SSL_get_cipher_bits(ssl, NULL));
	hoe_threadOwner->AddToLog(str);

	if ((temp = tls_get_commonName(ssl))==NULL)
		temp = "Not even a commonName found !";
	str.Format("[%s] Common Name: %s", hoe_threadConf.label,temp);
	hoe_threadOwner->AddToLog(str);
}

int CWrapThread::Run()
{
	int err;
	unsigned long cmdpar;
	CString str;
	int tmp;
	// TIMEVAL timeout={0,0};
	CConnection *lcon=NULL,*ccon=NULL;

	ASSERT (hoe_threadOwner != NULL);
	// _CrtMemState s1, s2, s3;
	//_CrtMemCheckpoint( &s1 );

	hoe_threadOwner->PostMessage(WM_USER+1,0,0);

	//lcon will be blocking
	lcon=new(CConnection)(hoe_clntSock);

	if (hoe_threadConf.type==1) {
		if (DoFTPProxyAuth(lcon)==-1) {
			//we suck
			goto quit;

		}
	} else {
		if (hoe_threadConf.sslin) {
			if (hoe_ssl_ctx_server==NULL) {
				str.Format("[%s] SSL listening is disabled !");
				hoe_threadOwner->AddToLog(str);
				goto quit;
			}
			cmdpar=1;
			ioctlsocket(hoe_clntSock,FIONBIO,&cmdpar);
			hoe_sslin=SSL_new(hoe_ssl_ctx_server);
			SSL_set_fd (hoe_sslin, hoe_clntSock);
			err = SSL_accept(hoe_sslin);

			while (err<=0) 
			{
				int err2 = SSL_get_error(hoe_sslin, err);
				if ((err2!=SSL_ERROR_WANT_READ)&&(err2!=SSL_ERROR_WANT_WRITE)) {
					str.Format("[%s] SSL_accept() = %d, %s", hoe_threadConf.label,err,
						(char *)ERR_error_string(ERR_get_error(), NULL));
					hoe_threadOwner->AddToLog(str);
					SSL_shutdown(hoe_sslin);
					SSL_free(hoe_sslin);
					goto quit;
				}
				if (hoe_threadDone) {
					SSL_shutdown(hoe_sslin);
					SSL_free(hoe_sslin);
					goto quit;
				}
				Sleep(1);
				err = SSL_accept(hoe_sslin);
			}
			delete lcon;
			lcon=new(CSSLConn)(hoe_clntSock,hoe_sslin);
			showsslinfo(hoe_sslin);
			cmdpar=0;
			ioctlsocket(hoe_clntSock,FIONBIO,&cmdpar);  
		}

		if (this->ResolveOut()) {
			str.Format("[%s] Unable to resolve %s (not valid hostname or ip)",hoe_threadConf.label,hoe_threadConf.outhost);
			AddToLog(str);
			goto quit;
		}
		hoe_threadOwner->PostMessage(WM_USER+1,2,0);
		str.Format("[%s] Connecting to %s (%s), port %d",hoe_threadConf.label,hoe_threadConf.outhost,hoe_threadConf.outhostip,hoe_threadConf.outport);
		AddToLog(str);

		ccon=this->ConnectWrap();
		if (ccon==NULL) {
			goto quit;
		}
		//ccon is blocking

		if (hoe_threadConf.sslout) {
			cmdpar=1;
			ioctlsocket(ccon->sock,FIONBIO,&cmdpar);  
			hoe_sslout=SSL_new(hoe_ssl_ctx);
			SSL_set_fd (hoe_sslout, ccon->sock);
			err = SSL_connect (hoe_sslout);

			while (err<=0) 
			{
				int errs = SSL_get_error(this->hoe_sslout, err);
				if ((errs != SSL_ERROR_WANT_READ) && (errs != SSL_ERROR_WANT_WRITE)&& (errs != SSL_ERROR_WANT_X509_LOOKUP)) {
					str.Format("[%s] SSL_connect() = %d, %s", hoe_threadConf.label,err,
						(char *)ERR_error_string(ERR_get_error(), NULL));
					AddToLog(str);
					SSL_shutdown(hoe_sslout);
					SSL_free(hoe_sslout);
					goto quit;
				}
				if (hoe_threadDone) {
					SSL_shutdown(hoe_sslout);
					SSL_free(hoe_sslout);
					goto quit;
				}
				Sleep(1);
				err = SSL_connect(hoe_sslout);
			}
			tmp=ccon->sock;
			delete ccon;
			ccon=new(CSSLConn)(tmp,hoe_sslout);     
			showsslinfo(hoe_sslout);
			cmdpar=0;
			ioctlsocket(ccon->sock,FIONBIO,&cmdpar);  
		}

		//we can block now, select() will do the trick
		//lame but working
		DoBounce(lcon,ccon);
	}
quit:
	if (lcon) {
		lcon->close();
		delete lcon;
	}
	if (ccon) {
		ccon->close();
		delete ccon;
	}

	//  _CrtMemCheckpoint( &s2 );
	//if ( _CrtMemDifference( &s3, &s1, &s2 ) )
	//      _CrtMemDumpStatistics( &s3 );
	//_CrtCheckMemory( );
	
	//wont remove from connections dialog yet, still active thread...
	hoe_threadOwner->PostMessage(WM_USER+1,1,0);

	str.Format("[%s] Closing connection from %s, port %d",hoe_threadConf.label,hoe_threadConf.fromhost,hoe_threadConf.fromport);
	AddToLog(str);

	return 0;
}


void CWrapThread::AddToLog(LPCTSTR szBuffer)
{
	hoe_threadOwner->AddToLog(szBuffer); 
}

int CWrapThread::DoBounce(CConnection *lcon, CConnection *ccon)
{
	int maxfd,nbyt;
	char buf[BUFLEN];
	fd_set fdsr, fdse;
	CString str;
	TIMEVAL timeout={0,50000};

	//ignored in windows anyway
	maxfd=((lcon->sock > ccon->sock) ? lcon->sock : ccon->sock) + 1;
	while (!hoe_threadDone) {
		FD_ZERO(&fdsr);
		FD_ZERO(&fdse);
		FD_SET(lcon->sock,&fdsr);
		FD_SET(lcon->sock,&fdse);
		FD_SET(ccon->sock,&fdsr);
		FD_SET(ccon->sock,&fdse);		
		if (select(maxfd, &fdsr, NULL, &fdse, &timeout) == -1) {
			AddToLog("select() error");
			return 1;
		}
		if (FD_ISSET(lcon->sock,&fdsr) || FD_ISSET(lcon->sock,&fdse)) {
			do {
				if ((nbyt = lcon->read(buf,BUFLEN)) <= 0)
					return 1;
				//str.Format("lcon read %d %s",nbyt,buf);
				//m_pOwner->AddToLog(str);
				if ((ccon->write(buf,nbyt)) <= 0)
					return 1;
			} while (lcon->wantread);
		} else
			if (FD_ISSET(ccon->sock,&fdsr) || FD_ISSET(ccon->sock,&fdse)) {
				do {
					if ((nbyt = ccon->read(buf,BUFLEN)) <= 0)
						return 1;
					//str.Format("ccon read %d %s",nbyt,buf);
					//m_pOwner->AddToLog(str);
					if ((lcon->write(buf,nbyt)) <= 0)
						return 1;
				} while (ccon->wantread);
			} //else m_pOwner->AddToLog("(debug) select() timeout");
	}
	return 0;
}


void writelog(CConnection *lcon,CString &welcome,int code)
{
	int i,i2;
	CString tmp;
	i=0;i2=0;
	while((i2=welcome.Find("\r\n",i))!=-1) {
		tmp.Format("%d",code);
		lcon->write(tmp+"- "+welcome.Mid(i,i2-i)+"\r\n");
		i=i2+2;
	}
}


int CWrapThread::DoFTPProxyAuth(CConnection *lcon)
{
	CString str,tmp;
	//	char buf[BUFLEN];
	int i,timeout,isssl=0;
	CString user,host;
	int port=21;
	unsigned long cmdpar;
	CFTPLines *cftp=NULL;
	int err;
	//well we should not block here ! timeout needs to work
	cmdpar=1;
	ioctlsocket(lcon->sock,FIONBIO,&cmdpar);

	lcon->write("220 WinSSLWrap FTP proxy server by HoE...\r\n");
	timeout=0;
	while (TRUE) {
next:
		if ((this->hoe_threadDone)||(timeout>5000)) {
			lcon->write("530 Timeout !\r\n");
			goto ferror;
		}
		i=lcon->GetLine(&str);
		//not whole line
		//m_pOwner->AddToLog("(debug)repeating");
		if (i==2) continue;
		//error
		if (i==-1) {
			lcon->write("530 Fatal error while getting line !\r\n");
			goto ferror;
		}
		//nothing to read
		if (i==1) {
			timeout++;
			//			m_pOwner->AddToLog("(debug)sleeping in main loop");
			//FIXME
			Sleep(5);
			//we dont select(), this sux
			continue;
		}
		timeout=0;
		//well we got line lets parse :P
		if (str.Left(4)=="QUIT") {
			lcon->write("221 Goodbye!\r\n");
			//just to let the client see our goodbye msg :P
			//in case windows decides not to flush data
			Sleep(10000);
			goto ferror;
		} else
			if (str.Left(4)=="PASS") {
				if (cftp==NULL) {
					lcon->write("530 Not logged in.\r\n");
					continue;
				}
				str="PASS "+str.Right(strlen(str)-5);
				cftp->postcommand(str);
				if (cftp->getreply()) {
					lcon->write("530 Error sending PASS...\r\n");
					goto cerror;
				}

				//m_pOwner->AddToLog("(debug)got PASS reply");
				if (cftp->lastline.Left(3)=="230") {           
					writelog(lcon,cftp->log,230);
					lcon->write("230 User logged in.\r\n");
				} else {
					lcon->write("530- "+cftp->lastline+"\r\n");
					lcon->write("530 PASS command rejected...\r\n");
					goto cerror;
				}
				if (isssl) {
					cftp->postcommand("PBSZ 0");
					if (cftp->getreply()) {
						lcon->write("530 Error getting PBSZ reply...\r\n");
						goto cerror;
					}

					if (cftp->lastline.Left(3)!="200") {
						writelog(lcon,cftp->log,530);
						lcon->write("530 PBSZ command rejected...\r\n");
						goto cerror;

					}
					cftp->postcommand("PROT C");
					if (cftp->getreply()) {
						//error
						lcon->write("530 Error getting PROT reply...\r\n");
						goto cerror;
					}

					if (cftp->lastline.Left(3)!="200") {
						writelog(lcon,cftp->log,530);
						lcon->write("530 PROT command rejected...\r\n");
						goto cerror;                  
					}
				}
				//m_pOwner->AddToLog("(debug)all went ok");
				//all went ok
				break;
			} else if (str.Left(4)=="USER") {
				if (cftp!=NULL) {
					lcon->write("530 Proxy is already connected to ftpd...\r\n");
					continue;
				}
				user=str.Right(strlen(str)-4);
				user.TrimLeft();
				i=user.ReverseFind('@');
				if (i<=0) {
					lcon->write("530 Format is USER name@host:port\r\n");
					continue;
				}
				host=user.Right(strlen(user)-i-1);
				user=user.Left(i);
				i=host.ReverseFind(' ');
				if (i<=0) {
					i=host.ReverseFind(':');
					if (i<=0) {
						port=21;
						i=0;
					}
				}
				if (i!=0) {
					port=atoi(host.Right(strlen(host)-i-1));
					host=host.Left(i);
				}
				this->hoe_threadConf.outhost=host;
				this->hoe_threadConf.outport=port;
				if (this->ResolveOut()) {
					str.Format("[%s] Unable to resolve %s (not valid hostname or ip)",hoe_threadConf.label,hoe_threadConf.outhost);
					AddToLog(str);
					lcon->write("530 Unable to resolve the hostname or ip...\r\n");
					continue;
				}
				hoe_threadOwner->PostMessage(WM_USER+1,2,0);

				str.Format("[%s] FTP Connecting to %s (%s), port %d",hoe_threadConf.label,hoe_threadConf.outhost,hoe_threadConf.outhostip,hoe_threadConf.outport);
				AddToLog(str);

				//connect to server and say USER
				CConnection *ccon=NULL;
				ccon=this->ConnectWrap();
				if (ccon==NULL) {
					lcon->write("530 Unable to connect...\r\n");
					continue;
				}
				//m_pOwner->AddToLog("(debug)connected");
				isssl=0;
				cftp=new CFTPLines(ccon,hoe_threadDone);
				ccon=NULL;//dont need anymore
				//ftps
				if (hoe_threadConf.ftptype==1) {
					cmdpar=1;
					ioctlsocket(cftp->ccon->sock,FIONBIO,&cmdpar);
					hoe_sslout=SSL_new(hoe_ssl_ctx);
					SSL_set_fd (hoe_sslout, cftp->ccon->sock);
					err = SSL_connect(hoe_sslout);

					while (err<=0) 
					{
						int errs = SSL_get_error(this->hoe_sslout, err);
						if ((errs != SSL_ERROR_WANT_READ) && (errs != SSL_ERROR_WANT_WRITE)&& (errs != SSL_ERROR_WANT_X509_LOOKUP)) {
							str.Format("[%s] SSL_connect() = %d, %s", hoe_threadConf.label,err,
								(char *)ERR_error_string(ERR_get_error(), NULL));
							AddToLog(str);
							SSL_shutdown(hoe_sslout);
							SSL_free(hoe_sslout);
							lcon->write("530 Unable to SSL_connect...\r\n");
							goto cerror;
						}
						if (hoe_threadDone) {
							SSL_shutdown(hoe_sslout);
							SSL_free(hoe_sslout);
							lcon->write("530 Unable to SSL_connect...\r\n");
							goto cerror;
						}
						Sleep(1);
						err = SSL_connect(hoe_sslout);
					}

					i=cftp->ccon->sock;
					delete cftp->ccon;
					cftp->ccon=new(CSSLConn)(i,hoe_sslout);
					showsslinfo(hoe_sslout);
					cmdpar=0;
					ioctlsocket(cftp->ccon->sock,FIONBIO,&cmdpar);
				}
				if (cftp->getreply()) {
					//error
					lcon->write("530 Error getting welcome message...\r\n");
					goto cerror;
				}

				if (hoe_threadConf.ftptype==1) goto dossl;

				//lets try go to SSL mode !
				cftp->postcommand("AUTH TLS");
				if (cftp->getreply()) {
					//error
					lcon->write("530 Error getting AUTH TLS reply...\r\n");
					goto cerror;
				}
				if (cftp->lastline.Left(3)=="234") {            
					cmdpar=1;
					ioctlsocket(cftp->ccon->sock,FIONBIO,&cmdpar);
					hoe_sslout=SSL_new(hoe_ssl_ctx);
					SSL_set_fd (hoe_sslout, cftp->ccon->sock);
					err = SSL_connect (hoe_sslout);

					while (err<=0) 
					{
						int errs = SSL_get_error(this->hoe_sslout, err);
						if ((errs != SSL_ERROR_WANT_READ) && (errs != SSL_ERROR_WANT_WRITE)&& (errs != SSL_ERROR_WANT_X509_LOOKUP)) {
							str.Format("[%s] SSL_connect() = %d, %s", hoe_threadConf.label,err,
								(char *)ERR_error_string(ERR_get_error(), NULL));
							AddToLog(str);
							SSL_shutdown(hoe_sslout);
							SSL_free(hoe_sslout);
							lcon->write("530 Unable to connect...\r\n");
							goto cerror;
						}
						if (hoe_threadDone) {
							SSL_shutdown(hoe_sslout);
							SSL_free(hoe_sslout);
							lcon->write("530 Unable to connect...\r\n");
							goto cerror;
						}
						Sleep(1);				
						err = SSL_connect(hoe_sslout);
					}

					i=cftp->ccon->sock;
					delete cftp->ccon;
					cftp->ccon=new(CSSLConn)(i,hoe_sslout);       
					showsslinfo(hoe_sslout);
					cmdpar=0;
					ioctlsocket(cftp->ccon->sock,FIONBIO,&cmdpar);
dossl:          
					str.Format("[%s] FTP Connection to %s (%s), port %d changed to SSL successfully...",hoe_threadConf.label,hoe_threadConf.outhost,hoe_threadConf.outhostip,hoe_threadConf.outport);
					AddToLog(str);					
					isssl=1;
				} else {
					str.Format("[%s] FTP Connection to %s (%s), port %d failed to change to SSL or doesnt support AUTH TLS...",hoe_threadConf.label,hoe_threadConf.outhost,hoe_threadConf.outhostip,hoe_threadConf.outport);
					AddToLog(str);
					if (hoe_threadConf.ftpreject) {
						lcon->write("530 Unable to get in SSL mode, rejecting...\r\n");
						goto cerror;
					}
				}

				str.Format("USER %s",user);
				cftp->postcommand(str);
				if (cftp->getreply()) {
					//error
					lcon->write("530 Error getting welcome message...\r\n");
					goto cerror;
				}

				if (cftp->lastline.Left(3)=="331") {            
					writelog(lcon,cftp->log,331);
					lcon->write("331 Password required...\r\n");
					cftp->resetlog();
				} else {
					writelog(lcon,cftp->log,530);
					lcon->write("530 USER command rejected...\r\n");
					goto cerror;
				}           
			} else {
				lcon->write("530 Not logged in.\r\n");
			}
	}
	ASSERT(cftp!=NULL);

	//make it blocking now
	//ccon
	cmdpar=0;
	ioctlsocket(cftp->ccon->sock,FIONBIO,&cmdpar);
	//lcon
	cmdpar=0;
	ioctlsocket(lcon->sock,FIONBIO,&cmdpar);

	this->DoBounce(lcon,cftp->ccon);
	ASSERT(cftp!=NULL);
	delete cftp;

	return 1;
cerror:
	if (cftp) {
		//	 ccon->close();
		delete cftp;
		cftp=NULL;
	}
	goto next;
ferror:
	if (cftp) {
		//	 ccon->close();
		delete cftp;
		//	 cftp=NULL;
	}
	return -1;

}

CConnection * CWrapThread::ConnectWrap()
{
	int cclnt;
	TIMEVAL timeout={0,50000};
	int maxfd;
	struct sockaddr_in sc;
	unsigned long cmdpar;
	fd_set fdsr, fdse;
	CString str;
	CConnection *ccon;
	struct sockaddr_in sourcedef;

	cclnt = socket (AF_INET, SOCK_STREAM, 0);

	memset(&sourcedef, '\0', sizeof(struct sockaddr_in));
	sourcedef.sin_addr.s_addr = INADDR_ANY;
	sourcedef.sin_family = AF_INET;
	sourcedef.sin_port = 0;

	int err = bind(cclnt, (struct sockaddr*) &sourcedef,sizeof (sourcedef)); 
	if (err==SOCKET_ERROR) {
		str.Format("[%s] Unable to bind",hoe_threadConf.label);
		AddToLog(str);
		closesocket(cclnt);
		return NULL;           
	}

	memset (&sc, '\0', sizeof(sc));
	sc.sin_family      = AF_INET;
	sc.sin_addr.s_addr = inet_addr (hoe_threadConf.outhostip);   /* Server IP */
	sc.sin_port        = htons     ((unsigned short)hoe_threadConf.outport);          /* Server Port number */

	cmdpar=1;
	ioctlsocket(cclnt,FIONBIO,&cmdpar);

	connect(cclnt, (struct sockaddr*) &sc,sizeof(sc));
	maxfd=cclnt+1;
	do {
		FD_ZERO(&fdsr);
		FD_ZERO(&fdse);
		FD_SET(cclnt,&fdsr);
		FD_SET(cclnt,&fdse);
		if (select(maxfd, NULL, &fdsr, &fdse, &timeout) == -1) {
			str.Format("[%d] select() error while connecting",hoe_threadConf.label);
			AddToLog(str);
			closesocket(hoe_clntSock);
			return NULL;
		}
		if (FD_ISSET(cclnt,&fdse)) {
			str.Format("[%s] Unable to connect to %s (%s), port %d",hoe_threadConf.label,hoe_threadConf.outhost,hoe_threadConf.outhostip,hoe_threadConf.outport);
			AddToLog(str);
			closesocket(hoe_clntSock);
			return NULL;
		}
		if (hoe_threadDone) {
			closesocket(hoe_clntSock);
			return NULL;
		}
		if (FD_ISSET(cclnt,&fdsr)) {
			break;
		}
	} while (TRUE);

	cmdpar=0;
	ioctlsocket(cclnt,FIONBIO,&cmdpar);

	return ccon=new(CConnection)(cclnt);

}

int CWrapThread::ResolveOut()
{
	struct sockaddr_in sa;
	struct hostent *h;
	unsigned long a;
	CThreadConfig &conf=hoe_threadConf;

	memset (&sa, '\0', sizeof(sa));
//	clock->Lock();
	if ((a=inet_addr(conf.outhost))!=INADDR_NONE) {
		if ((h = gethostbyaddr((char *) &a, sizeof(a), AF_INET))==0) {
			conf.outhostip=conf.outhost;
			//clock->Unlock();
			return 0;           
		}
		conf.outhost=h->h_name;
		memcpy(&sa.sin_addr,h->h_addr_list[0],h->h_length);   /* Server IP */
		conf.outhostip=inet_ntoa(sa.sin_addr);  
	} else  {
		h=gethostbyname(conf.outhost);
		if (h==NULL) {
			conf.outhost="";
			conf.outhostip="";
			//clock->Unlock();
			return 1;           
		} else {
			conf.outhost=h->h_name;
			memcpy(&sa.sin_addr,h->h_addr_list[0],h->h_length);   
			conf.outhostip=inet_ntoa(sa.sin_addr);
		}
	}
	//clock->Unlock();
	return 0;   
}



BEGIN_MESSAGE_MAP(CWrapThread, CWinThread)
	//{{AFX_MSG_MAP(CWrapThread)
	// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWrapThread message handlers
