#include "stdafx.h"
#include "wrap.h"
#include "wrapdlg.h"
#include "configdlg.h"
#include "servicesdlg.h"
#include "connectiondlg.h"
#include "threads.h"

#include <direct.h>
#include <openssl/err.h>
#include <openssl/ssl.h>
#include <openssl/rand.h>

#ifdef _DEBUG
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();
    
    // Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA
    
    // Implementation
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/)
: CDialog(CMainDlg::IDD, pParent),
m_mutex(FALSE, NULL),m_threadsmutex(FALSE,NULL)
{
    //{{AFX_DATA_INIT(CMainDlg)
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_hQuitting=0;
    //m_pListenThread = NULL;
}

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CMainDlg)
    DDX_Control(pDX, IDC_LOGWIN, m_HOE);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
//{{AFX_MSG_MAP(CMainDlg)
ON_WM_PAINT()
ON_WM_CLOSE()
ON_BN_CLICKED(IDC_PAUSE, OnPause)
ON_BN_CLICKED(IDC_STARTSTOP, OnStartstop)
ON_BN_CLICKED(IDC_QUIT, OnButtonQuit)
ON_COMMAND(ID_QUIT, OnTrayMenuQuit)
ON_WM_SYSCOMMAND()
ON_COMMAND(ID_ABOUT, OnTrayMenuAbout)
ON_MESSAGE(WM_USER,OnTrayMsg)
ON_MESSAGE(WM_USER+1,OnConnectionNews)
ON_BN_CLICKED(IDC_CONFIG2, OnButtonConfig)
ON_BN_CLICKED(IDC_SERVICES, OnButtonServices)
ON_COMMAND(ID_STARTSTOP, OnStartstop)
ON_BN_CLICKED(IDC_Clear, OnClear)
//}}AFX_MSG_MAP
ON_BN_CLICKED(IDC_CONNECTIONS, OnButtonConnections)
END_MESSAGE_MAP()

afx_msg LRESULT CMainDlg::OnConnectionNews(WPARAM wParam , LPARAM) {
//    int i;
	CString version,txt;
	//will get new info here form wrap thread
	//now we should update our list
    if ( wParam == 0 ) {
		m_pConnections++;
   	    version.LoadString(IDS_VERSION);
		txt.Format("%s - Connections : %d",version,m_pConnections);
		this->SetWindowText(txt);
		this->UpdateTrayIcon(txt);
		if (m_pConnectionsDlg) {
			m_pConnectionsDlg->RefreshItems();
		}
    } else
    if ( wParam == 1 ) {
		m_pConnections--;
   	    version.LoadString(IDS_VERSION);
		txt.Format("%s - Connections : %d",version,m_pConnections);
        this->SetWindowText(txt);
		this->UpdateTrayIcon(txt);
		if (m_pConnectionsDlg) {
			m_pConnectionsDlg->RefreshItems();
		}
    } else
    if ( wParam == 2 ) {
		if (m_pConnectionsDlg) {
			m_pConnectionsDlg->RefreshItems();
		}
	}
	return(0);
}

afx_msg LRESULT CMainDlg::OnTrayMsg(WPARAM , LPARAM lParam) {
    
    if (this->m_hQuitting==1) return(0);
    if (!this->IsWindowEnabled()) return(0);
    
    if ( lParam == WM_LBUTTONUP ) {
        if (this->IsWindowVisible()) {
            this->ShowWindow(SW_HIDE);  
            //this->SetForegroundWindow();
        } else {
            this->ShowWindow(SW_SHOW);  
            this->SetForegroundWindow();
        }
        //this->ShowWindow(SW_RESTORE);  
    } else {
        if ( lParam == WM_RBUTTONUP ) {
            POINT pt;
            CString str;
            char str1[10];
            CButton* pCheck = (CButton*) GetDlgItem(IDC_STARTSTOP);
            
            CMenu hMenu;
            hMenu.LoadMenu(IDR_TRAYMENU);
            pCheck->GetWindowText(str1,10);
            str=str1;
            hMenu.ModifyMenu(ID_STARTSTOP,MF_BYCOMMAND|MF_STRING,ID_STARTSTOP,str);
            //hMenu.GetMenuString(ID_STARTSTOP,str,flags);
            GetCursorPos(&pt);
            hMenu.SetDefaultItem(0,TRUE);
            this->SetForegroundWindow();
            hMenu.GetSubMenu(0)->TrackPopupMenu( TPM_LEFTALIGN | TPM_BOTTOMALIGN | TPM_LEFTBUTTON,pt.x, pt.y,this,NULL);
            hMenu.DestroyMenu();
        }
    }
	return(0);
}

void CMainDlg::UpdateTrayIcon(CString szIconStr) {
    static DWORD nim = NIM_ADD;
    HICON icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME); 
    NOTIFYICONDATA nid;
    
	if (m_pConnections) 
		icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME_CONNECTED); 
    
    nid.cbSize = sizeof (NOTIFYICONDATA);
    nid.hWnd = this->m_hWnd;
    nid.uID = 0;
    nid.uFlags = NIF_MESSAGE | NIF_TIP | NIF_ICON;
    nid.uCallbackMessage = WM_USER;
    nid.hIcon = icon;
    lstrcpy (nid.szTip, szIconStr);
    Shell_NotifyIcon (nim, &nid);
    nim = NIM_MODIFY;
    if (icon) DestroyIcon( icon );
    
}      

void CMainDlg::DeleteTrayIcon() {
    static DWORD nim = NIM_DELETE;
    HICON icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME); 
    NOTIFYICONDATA nid;
    
    nid.cbSize = sizeof (NOTIFYICONDATA);
    nid.hWnd = AfxGetApp()->GetMainWnd()->m_hWnd;
    nid.uID = 0;
    nid.uFlags = NIF_MESSAGE | NIF_TIP | NIF_ICON;
    nid.uCallbackMessage = WM_USER;
    nid.hIcon = icon;
    //lstrcpy (nid.szTip, szIconStr);
    Shell_NotifyIcon (nim, &nid);
    nim = NIM_MODIFY;
    if (icon) DestroyIcon( icon );
}      


BOOL CMainDlg::ReadConfigFile()
{    
    CWinApp *pApp=AfxGetApp();
	int count,i;
	CThreadConfig *conf=NULL;//,*head=NULL;
	CString cstr;

	certfile=pApp->GetProfileString("main","certfile",".\\winsslcrap.pem");
	logfile=pApp->GetProfileString("main","logfile","");
	autohide=pApp->GetProfileInt("main","autohide",0);
	autominimize=pApp->GetProfileInt("main","autominimize",0);
	count=pApp->GetProfileInt("main","count",0);
	//        head=NULL;
	i=0;
	while (i<count) {
		cstr.Format("Service-%d",i);
		conf=new(CThreadConfig);
		conf->inhost=pApp->GetProfileString(cstr,"inhost","");
		conf->outhost=pApp->GetProfileString(cstr,"outhost","");
		conf->label=pApp->GetProfileString(cstr,"label","error");
		conf->inport=pApp->GetProfileInt(cstr,"inport",0);
		conf->outport=pApp->GetProfileInt(cstr,"outport",0);
		conf->type=pApp->GetProfileInt(cstr,"type",0);
		conf->ftptype=pApp->GetProfileInt(cstr,"ftptype",0);
		conf->enabled=pApp->GetProfileInt(cstr,"enabled",0);
		conf->ftpreject=pApp->GetProfileInt(cstr,"ftpreject",0);
		conf->sslin=pApp->GetProfileInt(cstr,"sslin",0);
		conf->sslout=pApp->GetProfileInt(cstr,"sslout",0);

		conf->outhostip="";
		if (conf->type==1) { //ftp proxy has these clean
			conf->outhost="";
			conf->outport=0;
		}

		m_pThreadConfigs->AddTail(conf);
		i++;
	}
	return 0;
}

BOOL CMainDlg::WriteConfigFile()
{
    CWinApp *pApp=AfxGetApp();
    CString cstr,cstr1;
    int count,i;
    
    pApp->WriteProfileString("main","certfile",certfile);
    pApp->WriteProfileString("main","logfile",logfile);
    cstr.Format("%d",autohide);
    pApp->WriteProfileString("main","autohide",cstr);
    cstr.Format("%d",autominimize);
    pApp->WriteProfileString("main","autominimize",cstr);
    
    //delete old
	count=GetProfileInt("main","count",0);
    i=0;
    while (i<count) {
        cstr.Format("Service-%d",i);
        pApp->WriteProfileString(cstr,NULL,NULL);
        i++;
    }
    
    CThreadConfig *conf=NULL;

	POSITION pos = m_pThreadConfigs->GetHeadPosition();
	for (count=0;count < m_pThreadConfigs->GetCount();count++)
	{
//	while(m_pThreadConfigs->GetCount>count) {
		conf=m_pThreadConfigs->GetNext(pos);

		cstr1.Format("Service-%d",count);
        pApp->WriteProfileString(cstr1,"inhost",conf->inhost);
        pApp->WriteProfileString(cstr1,"outhost",conf->outhost);
        pApp->WriteProfileString(cstr1,"label",conf->label);
        cstr.Format("%d",conf->inport);
        pApp->WriteProfileString(cstr1,"inport",cstr);
        cstr.Format("%d",conf->outport);
        pApp->WriteProfileString(cstr1,"outport",cstr);
        cstr.Format("%d",conf->type);
        pApp->WriteProfileString(cstr1,"type",cstr);
        cstr.Format("%d",conf->ftptype);
        pApp->WriteProfileString(cstr1,"ftptype",cstr);
        cstr.Format("%d",conf->enabled);
        pApp->WriteProfileString(cstr1,"enabled",cstr);
        cstr.Format("%d",conf->ftpreject);
        pApp->WriteProfileString(cstr1,"ftpreject",cstr);
        cstr.Format("%d",conf->sslin);
        pApp->WriteProfileString(cstr1,"sslin",cstr);
        cstr.Format("%d",conf->sslout);
        pApp->WriteProfileString(cstr1,"sslout",cstr);
        
  //      conf=conf->next;
        //count++;
    }
    cstr.Format("%d",count);
    pApp->WriteProfileString("main","count",cstr);
    
    return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

BOOL CMainDlg::OnInitDialog()
{
    CDialog::OnInitDialog();
	
    // Add "About..." menu item to system menu.
	
    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);
	
	this->m_pConnectionsDlg=NULL;
	this->m_pConnections=0;
    HICON icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME); 
    this->SetIcon(icon,TRUE);
    if (icon) DestroyIcon( icon );

    CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	CString version,txt;
	version.LoadString(IDS_VERSION);
	txt.Format("%s - Connections : %d",version,m_pConnections);
    this->SetWindowText(txt);
	
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	
	this->UpdateTrayIcon(txt);
	
	m_pWrapThreads=new CWrapThreadList(1);
	m_pThreadConfigs=new CThreadConfigList(1);
		
	//lets read the config file
	this->ReadConfigFile();

	/* Setup all the global SSL stuff */
	SSL_load_error_strings();
	OpenSSL_add_ssl_algorithms();
	
	RAND_screen();
	if (!RAND_status() ) {
		AddToLog("RAND_screen failed to sufficiently seed PRNG !!!"); 
	}
	
    const char id[]="WinSSLWrap";

	ssl_ctx=SSL_CTX_new(SSLv23_client_method());
	if (!ssl_ctx) {
		AfxMessageBox("Failed making ssl_ctx");
	}
	//SSL_CTX_set_mode(ssl_ctx_server,SSL_MODE_AUTO_RETRY);
	SSL_CTX_set_session_cache_mode(ssl_ctx, SSL_SESS_CACHE_CLIENT);
	//SSL_CTX_set_timeout(ssl_ctx, 300); //its session timeout
	
	ssl_ctx_server=SSL_CTX_new(SSLv23_server_method());
	if (!ssl_ctx_server) {
		AfxMessageBox("Failed making ssl_ctx");
	}
	//SSL_CTX_set_mode(ssl_ctx_server,SSL_MODE_AUTO_RETRY);
	SSL_CTX_set_session_cache_mode(ssl_ctx_server, SSL_SESS_CACHE_SERVER);
	SSL_CTX_use_certificate_file(ssl_ctx_server, certfile,SSL_FILETYPE_PEM);
	SSL_CTX_use_PrivateKey_file(ssl_ctx_server,certfile,SSL_FILETYPE_PEM);
    SSL_CTX_set_session_id_context(ssl_ctx_server, (const unsigned char*)id,strlen(id));
	if (!SSL_CTX_check_private_key(ssl_ctx_server)) {
		AddToLog("Error loading private key/certificate, set correct file in options...");
		AddToLog("Listening in SSL mode will be disabled...");     
		if (ssl_ctx_server != NULL) SSL_CTX_free(ssl_ctx_server);
		ssl_ctx_server=NULL;
	}
	//SSL_CTX_set_tmp_rsa_callback(ssl_ctx_server, tmp_rsa_cb);
	//if(init_dh()) AddToLog("Diffie-Hellman initialization failed");
	
	//    SSL_CTX_set_timeout(ssl_ctx, options.session_timeout);
	
	
	
	if (autominimize) this->PostMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0L);
	
	// initialize the threads and let them start running!
	m_pListenThread = (CListenThread*)
		AfxBeginThread(RUNTIME_CLASS(CListenThread), THREAD_PRIORITY_NORMAL,
		0, CREATE_SUSPENDED);
	m_pListenThread->SetOwner(this);
	
	
	m_pListenThread->ResumeThread();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CMainDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


void CMainDlg::AddToLog(LPCTSTR szBuffer)
{
	CEdit* pBox = (CEdit*) GetDlgItem(IDC_LOGWIN);
	CString s,t;
	ASSERT(pBox != NULL);
	//mutex here
	CSingleLock sLock(&m_mutex);
	sLock.Lock();
	pBox->GetWindowText(s);
	CTime theTime = CTime::GetCurrentTime();
	s=s+theTime.Format("[%H:%M:%S] ");
	if (s.GetLength()>20000) s.Delete(0,5000);
	s += szBuffer;
	s += "\r\n";

	pBox->SetWindowText(s);
	
	int min,max;
	
	pBox->GetScrollRange(SB_VERT,&min,&max);
	pBox->SetScrollPos(SB_VERT,max,TRUE);
	pBox->LineScroll(max,0);
	
	
	FILE *log;
	if (logfile!="") {
		log=fopen(logfile,"a+");
		if (log) {		
			s=theTime.Format("[%Y %m %d %H:%M:%S] ")+szBuffer+"\n";
			fputs(s,log);
			fclose(log);
			}
		}
	sLock.Unlock();
	}

void CMainDlg::OnClose()
{
	int nCount = 0;
	DWORD   dwStatus;
	
	m_hQuitting=1;
	//beware this is passed few times until the thread is
	//finished (reason is that this thread is used for window
	//painting stuff, so if the thread wants to get something 
	//from window you need this thread running !
	
	CButton* pCheck = (CButton*) GetDlgItem(IDC_PAUSE);
	BOOL bPaused = ((pCheck->GetState() & 0x003) != 0);
	
	if (bPaused == TRUE)
	{
		pCheck->SetCheck(0);
		m_pListenThread->ResumeThread();
	}
	
	//when this stops all is stopped
	if (m_pListenThread != NULL)
	{
		VERIFY(::GetExitCodeThread(m_pListenThread->m_hThread, &dwStatus));
		if (dwStatus == STILL_ACTIVE)
		{
			nCount++;
			m_pListenThread->hoe_threadDone = 1;
			Sleep(10);
		}
		else
		{
			delete m_pListenThread;
			m_pListenThread = NULL;
		}
	}
	if (nCount==0) {
		//CThreadConfig* conftemp;
		//this is the real end !
		//should write config here maybe

		//CList SUX !!!
		while (!m_pThreadConfigs->IsEmpty()) {
			delete m_pThreadConfigs->RemoveHead();
		}
		delete m_pThreadConfigs;
		delete m_pWrapThreads;
//		while(this->m_pThreadConfigs!=NULL) {
			//this->m_pThreadConfigs=conftemp->next;
			//delete(conftemp);
			//conftemp=this->m_pThreadConfigs;
		//}
		if (ssl_ctx != NULL) SSL_CTX_free(ssl_ctx);
		ssl_ctx=NULL;
		if (ssl_ctx_server != NULL) SSL_CTX_free(ssl_ctx_server);
		ssl_ctx_server=NULL;
		this->DeleteTrayIcon();
		CDialog::OnClose();
	}
	Sleep(10);
	PostMessage(WM_CLOSE, 0, 0);
}

void CMainDlg::OnPause()
{
	CButton* pCheck = (CButton*) GetDlgItem(IDC_PAUSE);
	BOOL bPaused = ((pCheck->GetState() & 0x003) != 0);
	
	if (bPaused)
	{
		m_pListenThread->SuspendThread();
	}
	else
	{
		m_pListenThread->ResumeThread();
	}
}

void CMainDlg::OnStartstop() 
{
	DWORD   dwStatus;
	CButton* pCheck = (CButton*) GetDlgItem(IDC_STARTSTOP);
	ASSERT(pCheck!=NULL);
	//CString str;
	char str[10];
	
	CButton* pCheck1 = (CButton*) GetDlgItem(IDC_PAUSE);
	BOOL bPaused = ((pCheck1->GetState() & 0x003) != 0);
	
	if (bPaused == TRUE)
	{
		pCheck1->SetCheck(0);
		m_pListenThread->ResumeThread();
	}
	
	pCheck->GetWindowText(str,10);
	if (strcmp(str,"&Stop")==0) {
		m_pListenThread->hoe_threadDone = 1;
		/*
		VERIFY(::GetExitCodeThread(m_pListenThread->m_hThread, &dwStatus));
		while (dwStatus == STILL_ACTIVE) {
		VERIFY(::GetExitCodeThread(m_pListenThread->m_hThread, &dwStatus));
		Sleep(200);
	} */
	} else {
		//m_pListenThread->m_bDone=FALSE;
		//pCheck->SetWindowText("&Stop");     
		
		VERIFY(::GetExitCodeThread(m_pListenThread->m_hThread, &dwStatus));
		if (dwStatus != STILL_ACTIVE) {
			if (m_pListenThread!=NULL) {
				delete m_pListenThread;
				m_pListenThread = NULL;
				
			}
			m_pListenThread = (CListenThread*)
				AfxBeginThread(RUNTIME_CLASS(CListenThread), THREAD_PRIORITY_NORMAL,
				0, CREATE_SUSPENDED);
			m_pListenThread->SetOwner(this);
			m_pListenThread->ResumeThread();
		}
		
	}
}

void CMainDlg::OnButtonQuit() 
{
	this->ShowWindow(SW_HIDE);
	//m_pListenThread->m_bDone=TRUE;
	//this->AddToLog("Quitting..");     
	this->PostMessage(WM_CLOSE, 0, 0L);
}

void CMainDlg::OnTrayMenuQuit() 
{
	this->PostMessage(WM_CLOSE, 0, 0L);
}

void CMainDlg::OnSysCommand(UINT nID, LPARAM lParam) 
{
	if (nID==SC_CLOSE) {
		this->ShowWindow(SW_HIDE);
		this->PostMessage(WM_CLOSE, 0, 0L);
		return;
	} else {
		if (nID==SC_MINIMIZE) {
			this->ShowWindow(SW_HIDE);
		} else {
			if ((nID & 0xFFF0) == IDM_ABOUTBOX)
			{
				CAboutDlg dlgAbout;
				dlgAbout.DoModal();
			}
			else
			{
				CDialog::OnSysCommand(nID, lParam);
			}
		}
	}
}

void CMainDlg::OnTrayMenuAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();     
}



void CMainDlg::OnButtonConfig() 
{
	CConfigdlg dlg;
	dlg.SetOwner(this);
	int i;
	i=dlg.DoModal();
	if (i==IDOK) {
		autohide=dlg.autohide;
		autominimize=dlg.autominimize;
		if (certfile!=dlg.certfile) {
			AddToLog("You have to restart this application to update the certificate information !");
		}
		certfile=dlg.certfile;
		logfile=dlg.logfile;
		this->WriteConfigFile();
	}
	
}

BOOL CMainDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if ((wParam==2)&&(lParam==0)) {
		if (m_hQuitting==1) return CDialog::OnCommand(wParam, lParam);
		this->ShowWindow(SW_HIDE);
		return(TRUE);
	}
	return CDialog::OnCommand(wParam, lParam);
}

void CMainDlg::OnButtonServices() 
{
	CServicesDlg dlg;
	dlg.SetOwner(this);
	
	CThreadConfig *conf,*ctemp;

	dlg.m_pThreadConfigs=new CThreadConfigList(1);
	//now need to make a copy of list
	//wish it was easier
	POSITION pos=m_pThreadConfigs->GetHeadPosition();
	for (int i=0;i<m_pThreadConfigs->GetCount();i++) {
		ctemp=m_pThreadConfigs->GetNext(pos);
		conf=new CThreadConfig;
		*conf=*ctemp;
		dlg.m_pThreadConfigs->AddTail(conf);
	}
//	dlg.m_pThreadConfigs=*m_pThreadConfigs;
	/*conf=m_pThreadConfigs;
	while (conf!=NULL) {
		nhead=new(CThreadConfig);
		nhead->inhost=conf->inhost;
		nhead->inport=conf->inport;
		nhead->outport=conf->outport;
		nhead->outhost=conf->outhost;
		nhead->type=conf->type;
		nhead->label=conf->label;
		nhead->enabled=conf->enabled;
		nhead->sslin=conf->sslin;
		nhead->sslout=conf->sslout;
		nhead->ftpreject=conf->ftpreject;
		nhead->ftptype=conf->ftptype;
		nhead->next=NULL;
		if (dlg.m_pThreadConfig==NULL) {
			dlg.m_pThreadConfig=nhead; 
			head=nhead;
		}
		else
		{
			head->next=nhead;
			head=head->next;
		}
		conf=conf->next;
	}
	*/
	dlg.DoModal();
	//dlg.m_pThreadConfigs.RemoveAll();
	//delete dlg.m_pThreadConfigs;
//	dlg.m_pThreadConfig->
//	while (conf!=NULL) {
		//head=conf->next;
		//delete(conf);
		//conf=head;
	//}
}

void CMainDlg::OnClear() 
{
	CEdit* pBox = (CEdit*) GetDlgItem(IDC_LOGWIN);
	CString s;
	ASSERT(pBox != NULL);
	//mutex here
	CSingleLock sLock(&m_mutex);
	sLock.Lock();
	if (pBox != NULL)
	{         
		s="";
		pBox->SetWindowText(s);
		
		int min,max;
		pBox->GetScrollRange(SB_VERT,&min,&max);
		pBox->SetScrollPos(SB_VERT,max,TRUE);
		
	}
	sLock.Unlock();
}

void CMainDlg::OnButtonConnections()
{
	//AfxMessageBox("Will be enabled in next version, not finished yet :)");
	//return;
	CConnectionsDlg dlg;
	dlg.SetOwner(this);
	
    m_pConnectionsDlg=&dlg;
	dlg.DoModal();
	m_pConnectionsDlg=NULL;
}
